﻿if not BLTRCD then return end
local BLTRCD = BLTRCD

function BLTRCD:BuildGeneral()
BLTRCD.options.args = {
	configure = {
		order = 1,
		type = "execute",
		name = "Apply Changes",
		desc = "Apply the changes to the active cooldowns and reload the UI.",
		func = function()
				ReloadUI()
		end,
		width = "full",
	},
	module_opt = {
		order = 2,
		type = 'group',
		guiInline = true,
		name = "Module",
		get = function(info, value)
			return BLTRCD.db.profile.display[info[2]]
		end,
		set = function(info, value)
			BLTRCD.db.profile.display[info[2]] = value
			BLTRCD.DisplayFrame()
		end,
		args = {
			cooldownShow = {
				type = "toggle",
				name = "Cooldown",
				order = 1,
			},
			activeShow = {
				type = "toggle",
				name = "Active Cooldown",
				order = 2,
			},
			battleresShow = {
				type = "toggle",
				name = "Battle rez monitor",
				order = 3,
			},
		},
	},
	announceGroup = {
		order = 3,
		type = 'group',
		guiInline = true,
		name = "Announce",
		args = {
			startCDannounce = {
				type = "select",
				name = "Announce Casts",
				desc = "Ex: Alogon [Rallying Cry] START",
				order = 2,
				values = BLTRCD:selectAnnounce(0),
			},
			stopCDannounce = {
				type = "select",
				name = "Announce end casts",
				desc = "Ex: Alogon [Rallying Cry] END",
				order = 2,
				values = BLTRCD:selectAnnounce(0),
			},
			readyCDannounce = {
				type = "select",
				name = "Announce CD ready",
				desc = "Ex: Alogon [Rallying Cry] READY",
				order = 2,
				values = BLTRCD:selectAnnounce(0),
			},
			clickCDannounce = {
				type = "select",
				name = "Click to announce available",
				order = 2,
				values = BLTRCD:selectAnnounce(0),
			},
			customChannel = {
				type = "input",
				name = "Custom channel",
				order = 2,
				get = function(info, value)
					local id, name = GetChannelName(BLTRCD.db.profile[info[2]])
					return name
				end,
				set = function(info, value)
					local id, name = GetChannelName(value)
					BLTRCD.db.profile[info[2]] = id
				end,
			},
		},
	},
	cooldown_opt = {
		order = 4,
		type = 'group',
		guiInline = true,
		name = "Cooldown",
		get = function(info, value)
			return BLTRCD.db.profile.display[info[2]]
		end,
		set = function(info, value)
			BLTRCD.db.profile.display[info[2]] = value
			BLTRCD.DisplayCD()
		end,
		args = {
			scale = {
				order = 1,
				type = "range",
				name = 'Set Scale',
				desc = "Sets Scale of Raid Cooldowns",
				min = 0.3, max = 2, step = 0.01,
				set = function(info, value)
					BLTRCD.db.profile.display.scale = value;
					BLTRCD.DisplayCD()
				end,
			},
			nbbar = {
				order = 2,
				type = "range",
				name = 'Max bar per cd',
				desc = "Set max number of bars per cd",
				min = 1, max = 10, step = 1,
				set = function(info, value)
					BLTRCD.db.profile.display.nbbar = value;
					BLTRCD.DisplayCD();
				end,
			},
			growth = {
				order = 3,
				name = "Bar Grow Direction",
				type = 'select',
				values = {
					['LEFT'] = "Left",
					['RIGHT'] = "Right",
				},
			},
			catSorting = {
				order = 4,
				name = "Category Sorting",
				type = "select",
				values = {
					['class'] = "class",
					['name'] = "name",
					['cooldown'] = "cooldown",
				},
			},
			backdropcolor = {
				type = "toggle",
				name = "Class color",
				order = 5,
			},
			availabilityColor = {
				type = "toggle",
				name = "Availability color",
				desc = "Check to color text in green /red to view availability color",
				order = 6,
			},
			readymode = {
				type = "toggle",
				name = "Ready mode",
				desc = "Always show bars, putting READY on them when the CD is up",
				order = 7,
				get = function(info, value)
					return BLTRCD.db.profile.readymode
				end,
				set = function(info, value)
					BLTRCD.db.profile.readymode = value
				end,
			},
		},
	},
	activeCooldown_opt = {
		order = 5,
		type = 'group',
		guiInline = true,
		name = "Active Cooldown",
		get = function(info, value)
			return BLTRCD.db.profile.display[info[2]]
		end,
		set = function(info, value)
			BLTRCD.db.profile.display[info[2]] = value
			BLTRCD.DisplayCD()
		end,
		args = {
			activeX = {
				order = 1,
				type = "range",
				name = 'ActiveCD width',
				desc = "Set activeCD width",
				min = 50, max = 500, step = 1,
				set = function(info, value)
					BLTRCD.db.profile.display.activeX = value;
					BLTRCD.DisplayCD();
				end,
			},
			activeY = {
				order = 2,
				type = "range",
				name = 'ActiveCD height',
				desc = "Set activeCD height",
				min = 8, max = 96, step = 1,
				set = function(info, value)
					BLTRCD.db.profile.display.activeY = value;
					BLTRCD.DisplayCD();
				end,
			},
			nbActiveCD = {
				order = 3,
				type = "range",
				name = 'Max Active cd',
				desc = "Set max number of active cd",
				min = 0, max = 24, step = 1,
				set = function(info, value)
					BLTRCD.db.profile.display.nbActiveCD = value;
					BLTRCD.RearrangeActiveCD();
				end,
			},
			activeGrowth = {
				order = 4,
				name = "Bar Growth Direction",
				desc = "Choose a direction for your bar",
				type = 'select',
				values = {
					['UP'] = "Up",
					['DOWN'] = "Down",
				}, 
			},
			baricon = {
				type = "toggle",
				name = "Spell icon",
				desc = "Add an icon to the left of the bar",
				order = 5,
			},
		},
	},
	otherGroup = {
		order = 6,
		type = 'group',
		guiInline = true,
		name = "Misc",
		args = {
			ELVUI_SKIN = {
				type = "toggle",
				name = "ElvUI Skin",
				desc = "ElvUI Skin for Report Frame",
				order = 3,
			},
			show = {
				order = 4,
				name = "Show",
				desc = "Choose when you must show BLTRCD",
				type = "select",
				get = function()
					return BLTRCD.db.profile.show
				end,
				set = function(info, value)
					BLTRCD.db.profile.show = value
					BLTRCD.DisplayFrame()
				end,
				values = {
					['none'] = "Never",
					['group'] = "Group",
					['raid'] = "Raid",
					['always'] = "Always",
				},
			},
			saveFight = {
				type = "range",
				name = "Fight save",
				desc = "Number of fight saved",
				order = 5,
				min = 1,
				max = 20,
				softMin = 1,
				softMax = 20,
				step = 1,
				bigStep = 1,
			},
			minimap = {
				type = "toggle",
				name = "Show minimap icon",
				desc = "Show minimap icon",
				order = 6,
				get = function()
					return not BLTRCD.db.profile.minimap.hide
				end,
				set = function(key, value)
					BLTRCD.db.profile.minimap.hide = not value
					if value then BLTRCD.ShowMMIcon(true) else BLTRCD.ShowMMIcon(false) end
				end,
			},
			filteradditionalpeople = {
				type = "toggle",
				name = "Filter additional people",
				desc = "Filter additional people depending of the raid difficulty",
				order = 7,
			},
			showCombat = {
				order = 8,
				type = "toggle",
				name = "Only show in combat",
				desc = "Toggle to show only in combat",
			},
		},
	},
}
end